#
# uupk02.rb
#
# $Id: uupk02.rb,v 1.1 2000/11/23 08:19:14 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


N = 20
M = 5
x0 = NArray.sfloat(N)
x1 = NArray.sfloat(N)
x2 = NArray.sfloat(N)
y0 = NArray.sfloat(N)
y1 = NArray.sfloat(N)
y2 = NArray.sfloat(N)
a = NArray.sfloat(M)

#-----------------------------------------------------------------------
dt = 1.0/(N-1)
for j in 0..M-1
  jj = j*2+1
  a[j] = (-1.0)**(j+1) *2.0/(jj*PI)
end

for i in 0..N-1
  t = dt*i*2*PI
  x0[i] = dt*i
  y1[i] = a[0]*cos(t)
  y2[i] = 0.0
  for j in 0..M-1
    jj = j*2+1
    yy = a[j]*cos(jj*t)
    y2[i]  = y2[i] + yy
  end

  y0[i] = (y1[i]+y2[i])/2.0
  dy = (y1[i] - y2[i]).abs
  x1[i] = x0[i] - dy/5
  x2[i] = x0[i] + dy/5
end

#-----------------------------------------------------------------------
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm
sglset('LCLIP', true)

usspnt(N, x0, y0)
usspnt(N, x1, y1)
usspnt(N, x2, y2)
uspfit
grstrf

usdaxs

uverb(N, x0, y1, y2)

uusebt(3)
uusebi(33)
uherb(N, x1, x2, y0)

uusmkt(4)
uusmki(21)
uumrk(N, x0, y0)

grcls

